// doors.wdl


include <structures.wdl>;


var Distance;




function door_event()
{
	if (you == player)
	{
		wait(1);
	} 	
}



define DoorNr, skill1;          // door number
define AngleOpen, skill2;       // door open at "AngleOpen" degrees
define SpeedOpen, skill3;       // speed while door opens / close
define TimeOpenDoor, skill4;    // seconds before door close
define Area, skill5;            // needed for triggersystem
define door_angle, skill80;
// uses: DoorNr, AngleOpen, SpeedOpen, TimeOpenDoor, Area;
action door
{
	my.enable_entity = on;
	my.event = door_event;
	
	my.door_angle = my.pan + my.AngleOpen; 
	door_IsMoving[my.DoorNr] = 0;          // at start door is not rotating
	
	
	while(1)
	{		
		if (activeArea[my.Area] == 0)       // connection to triggersystem
		{
			my.invisible = off;
			my.passable = off;
		}
		else
		{
			my.invisible = on;
			my.passable = on;
		}
		
		if (menu_active == 0)
		{
		
			if ((DoorOpenWithNumber[my.DoorNr] == 1) && (door_IsMoving[my.DoorNr] == 0) ) // if button number = door number AND
			{																									   // ... door is currently not rotating then ...
				door_isMoving[my.DoorNr] = 1;																// ... door opens
				DoorOpenWithNumber[my.DoorNr] = 0;														
			
				if (my.SpeedOpen > 0)
				{
					if (!snd_playing(snd_kanalgitter_handle))
					{
						snd_kanalgitter_handle = snd_play(snd_kanalgitter,100,0);					
					}
					
					while(my.pan <= my.door_angle)																	
					{																											
						if (menu_active == 0)
						{
							my.pan += my.SpeedOpen * time;
						}
					
						wait(1);
					}
				}
			
			else
			{
				if (!snd_playing(snd_kanalgitter_handle))
					{
						snd_kanalgitter_handle = snd_play(snd_kanalgitter,100,0);					
					}
					
					while(my.pan >= my.door_angle)																	
					{																											
						if (menu_active == 0)
						{
							my.pan -= abs(my.SpeedOpen) * time;
						}
					
						wait(1);
					}
			}
			
		sleep(my.TimeOpenDoor);																			
		
		if (my.SpeedOpen > 0)
		{
			if (!snd_playing(snd_kanalgitter_handle))
				{
					snd_kanalgitter_handle = snd_play(snd_kanalgitter,100,0);					
				}
				
				while(my.pan >= (my.door_angle-my.AngleOpen))
				{
					if (menu_active == 0)
					{
						my.pan -= my.SpeedOpen * time;
					}
		
					wait(1);
				}	
		}
		else
		{
			if (!snd_playing(snd_kanalgitter_handle))
				{
					snd_kanalgitter_handle = snd_play(snd_kanalgitter,100,0);					
				}
				
				while(my.pan <= (my.door_angle+abs(my.AngleOpen)))
				{
					if (menu_active == 0)
					{
						my.pan += abs(my.SpeedOpen) * time;
					}
		
					wait(1);
				}	
		
		}
		
		door_isMoving[my.DoorNr] = 0;														
		my.pan = my.door_angle-my.AngleOpen;											
		
		
		sleep(3);
		}
	}
		
	wait(1);
	}
	
	
}


define ElevatorNr, skill1;
define EndPosZ, skill2;
define StartPosZ, skill3;
define WaitBeforeStart, skill4;
define WaitBeforeBack, skill5;
define Area, skill6;
define Speed, skill7;
//uses: ElevatorNr, EndPosZ, WaitBeforeStart, WaitBeforeBack, Area, Speed;
action elevator
{
	my.StartPosZ = my.z;
	
	while(1)
	{
		
		if (activeArea[my.Area] == 0)
		{
			my.invisible = off;
			my.passable = off;
		} 
		else
		{
			my.invisible = on;
			my.passable = on;
		}
		
		if ( menu_active == 0)
		{
			if (ActivateElevatorWithNumber[my.ElevatorNr] == 1)
			{
				sleep(my.WaitBeforeStart);
				Elevator_IsMoving[my.ElevatorNr] = 1;

				if (my.EndPosZ > my.StartPosZ)
				{
					while (my.z < my.EndPosZ)
					{
						if (menu_active == 0)
						{
							my.z += my.Speed * time;
						}
						
						wait(1);
					}
					
					my.z = my.EndPosZ;
			
					sleep(my.WaitBeforeBack);
			
			
			
					while(my.z > my.StartPosZ)
					{
						if (menu_active == 0)
						{
							my.z -= my.Speed * time;
						}
						wait(1);
					}
					
					my.z = my.StartPosZ;
				}
			
				if (my.EndPosZ < my.StartPosZ)
				{
			
			
			while (my.z > my.EndPosZ)
			{
				if (menu_active == 0)
				{
					my.z -= my.Speed * time;
				}
				wait(1);
			}
			
			my.z = my.EndPosZ;
			sleep(my.WaitBeforeBack);
			
			while(my.z < my.StartPosZ)
			{
				if (menu_active == 0)
				{
					my.z += my.Speed * time;
				}
				
				wait(1);
			}
			
			my.z = my.StartPosZ;
		}
			
			
		ActivateElevatorWithNumber[my.elevatorNr] = 0;
		Elevator_IsMoving[my.elevatorNr] = 0;						
		}
		}
		wait(1);
	}
}





function DoorOpen()																						
{
	DoorOpenWithNumber[my.DoorNr] = 1;	  // which door to activate? 
	DoorOpenWithNumber[my.skill4] = 1;
}

function ActivateElevator()
{
	ActivateElevatorWithNumber[my.ElevatorNr] = 1;  // which elevator to activate?
}

function doorlever_animate
{
	var lever_Anim;
	
	lever_Anim = 0;
	
	my.enable_sonar = off;
	my.enable_shoot = off;
	
	if (my.tilt >= 0) 
	{
	
		while(my.tilt >= -70)
		{
			if (menu_active == 0)
			{
				my.tilt -= 2 * time;
			}
			wait(1);
		}
	}
	
	if (my.tilt <= -70)
	{
		while(my.tilt < 0)
		{
			if (menu_active == 0)
			{
				my.tilt += 2 * time;
			}
			wait(1);
		}
	}
	
	my.tilt = 0; 
	
	lever_Anim = 0;
	wait(4);
}

function doorbutton_animate
{
	var button_Anim;
	var OriginalPos[3];
	
	button_Anim = 0;
	
	
	my.enable_sonar = off;
	my.enable_shoot = off;
	
	
	while(my.skill98 < 2)  // animation time
	{
		if (menu_active == 0)
		{
		
		my.skill98+ = 0.11 * time;
		ent_move(vector(0.2 * time,0,0),nullvector);
		}
		wait(1);
	}
	
	
	my.skill98 = 2;
	
	
	while(my.skill98 > 0)
	{
		if (menu_active == 0)
		{
		
		my.skill98 -= 0.11 * time;
		
		ent_move(vector(-0.2 * time,0,0),nullvector);
	}
		wait(1);
	}
	
	my.x = my.skill90; // set object to start values
	my.y = my.skill91; 
	my.z = my.skill92;  
	my.skill93 = 0;
	my.skill98 = 0;
	
	
	button_Anim = 0;
	wait(4);
}

function event_doorlever
{
	
	if (event_type == event_sonar) || (event_type == event_shoot)	// trace successfully?
	{
		if (key_pressed(key_Player_Use) == on && door_isMoving[my.DoorNr] == 0)
		{
			Doorlever_animate();
			DoorOpen();	
		}
	}

	wait(4);
}


// door lever
define DoorNr, skill1;
define Area, skill2;
// uses: DoorNr, Area;
action door_lever
{
	
	wait(4);
	
	my.enable_sonar = on;
	my.enable_shoot = on;																					
	my.event = event_doorlever;																			
	
	while(1)
	{
		
		if (activeArea[my.Area] == 0)
		{
			my.invisible = off;
			my.passable = off;
		}
		else
		{
			my.invisible = on;
			my.passable = on;
		}
		
		if (door_IsMoving[my.DoorNr] == 1)															
		{																										
			my.enable_sonar = off;
			my.enable_shoot = off;
			
		}
		else
		{
			my.enable_sonar = on;
			my.enable_shoot = on;
			
		}
		Distance = vec_dist(player.x, my.x);  // distance to traced object													
		wait(1);
	}
}


function event_doorbutton
{
	
	if (event_type == event_sonar) || (event_type == event_shoot)	// trace successfully?
	{
	
		if (menu_active == 0)
		{
		
		if (key_pressed(key_Player_Use) == on && my.skill93 == 0 && hand_display.pos_x == 0)
		{
			if (door_IsMoving[my.DoorNr] == 0 && my.flag1 == on)
			{
				DoorOpen();
				my.skill93 = 1;
			}
			
			if (door_isMoving[my.skill4] == 0 && my.flag4 == on)
			{
				DoorOpen();
				my.skill93 = 1;
			}
			
			if (elevator_IsMoving[my.ElevatorNr] == 0 && my.flag2 == on)
			{
				ActivateElevatorWithNumber[my.skill2] = 1;
				my.skill93 = 1;
			}
			
			if (SpecialObject_IsMoving[my.skill3] == 0 && my.flag3 == on)
			{
				SpecialObject_ActivateWithNumber[my.skill3] = 1;
			}
			
			if (DoorOpenWithNumber[my.skill1] == 1 || ActivateElevatorWithNumber[my.skill2] == 1 || SpecialObject_ActivateWithNumber[my.skill3] == 1)
			{
				Doorbutton_animate();
			}
		}
}
}
	wait(4);

	

}

// door button
define DoorNr, skill1;
define ElevatorNr, skill2;
define SpecialObjectNr, skill3;
define DoorNr2, skill4;
define ActivateDoor, flag1;
define AktivateElevator, flag2;
define ActivatespecialObject, flag3;
define ActivateDoorNr2, flag4;
define Area, skill5;
// uses: DoorNr,elevatorNr,ActivateDoor, Aktivateelevator, SpecialObjectNr, DoorNr2, ActivateSpecialObject, ActivateDoorNr2, Area;
action door_button
{
	
	wait(4);
	my.enable_sonar = on;
	my.enable_shoot = on;																					
	my.event = event_doorbutton;																		
	
	my.skill90 = my.x;
	my.skill91 = my.y;
	my.skill92 = my.z;
	
	my.skill98 = 0; 
						 
	
	while(1)
	{
		
		if (activeArea[my.Area] == 0)
		{
			my.invisible = off;
			my.passable = off;
		}
		else
		{
			my.invisible = on;
			my.passable = on;
		}
		
		if (door_IsMoving[my.DoorNr] == 1 || door_IsMoving[my.DoorNr2] == 1 || Elevator_IsMoving[my.ElevatorNr] == 1 || specialObject_IsMoving[my.SpecialObjectNr] == 1)															// solange die dazugehrige Tr in Bewegung ist ...
		{																											
			my.enable_sonar = off;
			my.enable_shoot = off;
			
			
		}
		else
		{
			my.enable_sonar = on;
			my.enable_shoot = on;
			
		}
			
		wait(1);
	}
}


