include <structures.wdl>;

entity* player;                             // the player entity

string CollEntityWithPlayer;                // which entity coll. with the player?
font font_arial_player = "Arial",1,16;  // players health display font

var jump_time = 1;
var PlayerIsJumping = 0;                    // set to 1 if player is jumping

bmap pic_PlayerIsDead = <PlayerIsDead.tga>;

panel pan_Health_Player                        // players health display
{
	pos_x = 2000;
	pos_y = 0;
	layer = 21;
	digits = 0,0, 3, font_arial_player, 1, player.skill4;  // current health
	digits = 40,0,3, font_arial_player, 1, player.skill3;  // max health
	flags = overlay, visible, refresh;
}

panel pan_PlayerIsDead
{
	bmap = pic_PlayerIsDead;
	pos_x = -2000;
	pos_y = 0;
	layer = 0;
	flags = visible;
}


bmap Hand_tga = <Hand.tga>;

panel hand_display
{
	bmap = Hand_tga;
	pos_x = -200;
	pos_y = 0;
	layer = 1;
	scale_x = 0.2;
	scale_y = 0.2;
	flags = overlay, refresh,visible;
}

function player_event                        // players event function
{
	str_for_entfile(CollEntityWithPlayer,you); // which entity coll. with the player?
	wait(2);
	
	if (str_cmpi(CollEntityWithPlayer,"mummy.mdl") == 1 ) // find out the filename of the coll. entity( here: enemy "mummy.mdl")
	{																		// it is very useful -> each type of enemy can produce different damage at the player
		my.skill4 -= 1;  // decrease players health
				
			if (my.skill4 <=0) // if players health <= 0 -> death
			{
				// player dead
				
				my.skill4 = 0;   // players current health is never less than 0
				
				vec_set(temp,my.x);  
      		temp.z -= 4000; // trace 4000 Quants down
				player.passable = on;
		
				trace_mode = ignore_me+ignore_sprites+USE_BOX + ignore_passable;  // trace options
				result = trace(my.x, temp);  
				
				camera.z = camera.z - result - 30;
				camera.roll = 90;
				
			}
	}
	
	
}





define MoveSpeed, skill1;             // speed of the player ( forward and backward )
define MoveSpeedSide, skill2;         // speed of the player ( step left and step right )
define MaxHealth, skill3;             // set the MaxHealth and CurrentHealth 
define CurrentHealth, skill4;
// title: Player Values
// uses: MoveSpeed,MoveSpeedSide,MaxHealth,CurrentHealth    
action action_player 
{
var force[3];
var friction;
var dist[3];

var TraceTo[3];
var TraceFrom[3];
var Distance2;




my.enable_entity = on;
my.enable_impact = on;
my.event = player_event;
my.skill20 = 0;
my.skill80 = 1;


if (my.MaxHealth < my.CurrentHealth)     // the current health is never above max health
{
	my.CurrentHealth = my.MaxHealth;
}

	
	while(1)
	{
		
		player = me;
		
		if (player.CurrentHealth > 0)
		{
			pan_PlayerIsDead.pos_x = -2000;
		}
		else
		{
			pan_PlayerIsDead.scale_x = screen_size.x / 800;
			pan_PlayerIsDead.scale_y = screen_size.y / 600;
			pan_PlayerIsDead.pos_x = 0;
		}
		
		if (menu_active == 1)
		{
			pan_PlayerIsDead.pos_x = -2000;
		}
		
		vec_set(temp,my.x);  
      temp.z -= 4000; // trace 4000 Quants down
		
		
		trace_mode = ignore_me+ignore_sprites+USE_BOX + ignore_passable + ignore_models;  // trace options
		result = trace(my.x, temp);  
		
		
		
		
		if (result > 5) // player is in the air -> no movement
		{
		  force.x = 0;
		  force.y = 0;
		  force.z = -2;
		  friction = 0.1;
		} else
		{
			force.x = 0;
			force.y = 0;
			force.z = -0.5 * result;
			friction = 0.7;
		}
				
	
	
		// the structures for key_pressed() are defined in structures.wdl
		
		// move forward
		if (key_pressed(key_Player_MoveForward) == on && player.CurrentHealth > 0)
		{
			if (result <=5) 
			{			
				force.x = my.MoveSpeed;  			
			}
		}
		
			
		// move backward
		if (key_pressed(key_Player_MoveBackward) == on && player.CurrentHealth > 0) 
		{
			if (result <=5)	
			{
				force.x = -1 * my.MoveSpeed;   
			}
			
			
		}

		
		// step left
		if (result <=5)
		{
		
		if (key_pressed(key_Player_StepLeft) == on && player.CurrentHealth > 0) 
		{
			force.y = 1 * my.MoveSpeedSide; 
			
		}
		}
		
		
		// step right
		if (result <=5)
		{
		
		if (key_pressed(key_Player_StepRight) == on && player.CurrentHealth > 0) 
		{
			force.y = -1 * my.MoveSpeedSide;  
		}
		}
		
		
		
		// jump
		if (result <=5)
		{
			if (key_pressed(key_Player_Jump) == on && PlayerIsJumping == 0 && player.CurrentHealth > 0) 
			{
				PlayerIsJumping = 1;
			}
		}	
			
			if (PlayerIsJumping == 1)
			{
				if (jump_time > -1)
				{
					
					force.z = 20;
					jump_time -= 0.05 * time;
					
					
					
				}
			}
			
			if (result <= 5)
			{
				PlayerIsJumping = 0;
				jump_time = 1;
			}
		
		
		
		my.SKILL11 = TIME*force.X + max(1-TIME*friction,0)*my.SKILL11; 
		my.SKILL12 = TIME*force.Y + max(1-TIME*friction,0)*my.SKILL12; 
		my.SKILL13 = TIME*force.Z + max(1-TIME*friction,0)*my.SKILL13; 

		dist.X = TIME * my.SKILL11; 
		dist.Y = TIME * my.SKILL12; 
		dist.Z = TIME * my.SKILL13; 
		
		move_mode = ignore_passable + glide;

		ent_move(dist, nullvector);   // move the player
		
		
		
		
		
		TraceTo.x = Screen_Size.x/2;  // trace from players position 100 quants inside the middle of screen
		TraceTo.y = Screen_Size.y/2;
		TraceTo.z = 100;
		
		TraceFrom.x = my.x;
		TraceFrom.y = my.y;
		TraceFrom.z = my.z + 30;
		
		vec_for_screen(TraceTo, camera); // convert 2D vector to 3D vector
		
		trace_mode = ignore_me + activate_sonar + activate_shoot + ignore_passable;
		
		distance2 = trace(TraceFrom.x, TraceTo); // distance from player to coll. element
		
		hand_display.pos_x = -200;  // display not visible
		
		// the panel "hand_display" shows only the hand if one of the two buttons (button or lever) was found by the trace-function
		if (you != null)
		{
		
			str_for_entfile(CollEntityWithPlayer,you); // which entity coll. with the player?
		
	
			if (str_cmpi(CollEntityWithPlayer,"me_tuerschalter.wmb") == 1 || str_cmpi(CollEntityWithPlayer,"me_tuerhebel.wmb") == 1)
			{
				hand_display.pos_x = 0;
			}
		}
		
		
		
		
		
		
		TraceTo.x = Screen_Size.x-(Screen_Size.x/4);  // trace again ( reason: if the weapon is inside the wall, the weapon moves backward )
		TraceTo.y = Screen_Size.y/2;
		TraceTo.z = 100;
		
		TraceFrom.x = my.x;
		TraceFrom.y = my.y;
		TraceFrom.z = my.z + 30;
		
		vec_for_screen(TraceTo, camera); // convert 2D vector to 3D vector
		
		trace_mode = ignore_me + activate_sonar + activate_shoot + ignore_passable; 
		
		Weapon_DistanceToObstacle = trace(TraceFrom.x, TraceTo); // distance between player and obstacle -> otherwise distance = 0
		
		wait(1);
	}
}
