// weapons.wdl

include <structures.wdl>;

font font_arial = "Arial",1,16;

var player_dist;
var bullet_speed;
var plate_speed;

var handle_nummer;


var ShotYes;

entity* E_MuzzleFlash;        
var _muzzle_vert;



bmap crosshair_map = <crosshair.tga>;



sound gotgun_snd = <gotgun.wav>;    // sound if you pick up a gun
sound gotmed_snd = <gotmed.wav>;
sound shoot_snd = <shoot.wav>;      // sound if you shoot


panel crosshair_pan
{
	bmap = crosshair_map;
	layer = 20;	
	pos_x = 0;
	pos_y = 0;
	flags = transparent, overlay, refresh, d3d;
}

panel Panel_ValuesWeapon1                                        // selected weapon -> MaxAmmo & CurrentAmmo 
{
	pos_x = 2000;
	pos_y = 0;
	layer = 21;
	digits = 0,0, 3, font_arial, 1, Weapon_CurrentAmmo[0];
	digits = 40,0,3, font_arial, 1, Weapon_MaxAmmo[0];
	flags = overlay, visible, refresh;
}

panel Panel_ValuesWeapon2													  // selected weapon -> MaxAmmo & CurrentAmmo 
{
	pos_x = 2000;
	pos_y = 0;
	layer = 21;
	digits = 0,0, 3, font_arial, 1, Weapon_CurrentAmmo[1];
	digits = 40,0,3, font_arial, 1, Weapon_MaxAmmo[1];
	flags = overlay, visible, refresh;
}

panel Panel_ValuesWeapon3													  // selected weapon -> MaxAmmo & CurrentAmmo 
{
	pos_x = 2000;
	pos_y = 0;
	layer = 21;
	digits = 0,0, 3, font_arial, 1, Weapon_CurrentAmmo[2];
	digits = 40,0,3, font_arial, 1, Weapon_MaxAmmo[2];
	flags = overlay, visible, refresh;
}

panel Panel_ValuesWeapon4													  // selected weapon -> MaxAmmo & CurrentAmmo 
{
	pos_x = 2000;
	pos_y = 0;
	layer = 21;
	digits = 0,0, 3, font_arial, 1, Weapon_CurrentAmmo[3];
	digits = 40,0,3, font_arial, 1, Weapon_MaxAmmo[3];
	flags = overlay, visible, refresh;
}

text Panel_slash
{
	pos_x = 2000;
	pos_y = 0;
	font = font_arial;
	layer = 21;
	string = "/";
	scale_x = 5;
	flags = visible;
}

panel statusbar																	// background ( current values of player & selected weapon )
{
	bmap = <statusbar_800.tga>;
	pos_x = 2000;
	pos_y = 0;
	layer = 20;
	flags = visible, refresh;
}

panel Weapon_Zoom																	// if weapon 3 is in zoom mode
{
	bmap = <Ar18_Zoom_800.tga>;
	pos_x = -2000;
	pos_y = 0;
	layer = 19;
	flags = visible, refresh;
}


function game_init();                // mainfunction weapon handling
function get_Weapon1();              // if you pick up a weapon
function get_Weapon2();
function get_Weapon3();
function get_Weapon4();
function Weapon_SetStartValues();    // you can define the start values for each weapon
function move_bulletWeapon1();       // bullet movement, coll. detection, etc. 
function move_bulletWeapon2();
function move_bulletWeapon3();
function move_bulletWeapon4();
function remove_me();




//function init_muzzle();

//////////////////////////////////////////////////////////////


string bullet_Weapon1_mdl = <bullet_Weapon1.mdl>;  // very important: each type of weapon can produce different damage
string bullet_Weapon2_mdl = <bullet_Weapon2.mdl>;  
string bullet_Weapon3_mdl = <bullet_Weapon3.mdl>;
string bullet_Weapon4_mdl = <bullet_Weapon4.mdl>;



entity* Weapon1;
action action_Weapon1               
{
	
	Weapon1 = me;

	
	while(1)
	{
	
	if (Weapon_DistanceToObstacle<40)
	{
		if (Weapon_DistanceToObstacle == 0)
		{
			temp.x = my.skill12;
		} 
		else
		{
			temp.x = my.skill12+(Weapon_DistanceToObstacle-40);
		}
	}
	else
	{
		temp.x = my.skill12;
	}
	
	temp.y = my.skill13;
	temp.z = my.skill14;
	my_pos.x = temp.x;
	my_pos.y = temp.y;
	my_pos.z = temp.z;
	vec_rotate(my_pos, camera.pan);
	my_pos.x += camera.x;
	my_pos.y += camera.y;
	my_pos.z += camera.z;
	my.x = my_pos.x;
	my.y = my_pos.y;
	my.z = my_pos.z;
	my.pan = camera.pan;
	my.tilt = camera.tilt;
	
	wait(1);
	}
}





entity* Weapon2;
action action_Weapon2
{	
	Weapon2 = me;
	
	while(1)
	{	
	
		if (Weapon_DistanceToObstacle<40)
		{
			if (Weapon_DistanceToObstacle == 0)
			{
				temp.x = my.skill12;
			} 
			else
			{
				temp.x = my.skill12+(Weapon_DistanceToObstacle-40);
			}
		}
		else
		{
			temp.x = my.skill12;
		}
		
	
		temp.y = my.skill13;
		temp.z = my.skill14;
		my_pos.x = temp.x;
		my_pos.y = temp.y;
		my_pos.z = temp.z;
		vec_rotate(my_pos, camera.pan);
		my_pos.x += camera.x;
		my_pos.y += camera.y;
		my_pos.z += camera.z;
		my.x = my_pos.x;
		my.y = my_pos.y;
		my.z = my_pos.z;
		my.pan = camera.pan;
		my.tilt = camera.tilt;
	
		wait(1);
	}	
}


entity* Weapon3;
action action_Weapon3
{
	Weapon3 = me;
	
	while(1)
	{
		if (Weapon_DistanceToObstacle<40)
		{
			if (Weapon_DistanceToObstacle == 0)
			{
				temp.x = my.skill12;
			} 
			else
			{
				temp.x = my.skill12+(Weapon_DistanceToObstacle-40);
			}
		}
		
		else
		{
			temp.x = my.skill12;
		}
			
	
	temp.y = my.skill13;
	temp.z = my.skill14;
	my_pos.x = temp.x;
	my_pos.y = temp.y;
	my_pos.z = temp.z;
	vec_rotate(my_pos, camera.pan);
	my_pos.x += camera.x;
	my_pos.y += camera.y;
	my_pos.z += camera.z;
	my.x = my_pos.x;
	my.y = my_pos.y;
	my.z = my_pos.z;
	my.pan = camera.pan;
	my.tilt = camera.tilt;
	
	wait(1);
	}
}


entity* Weapon4;
action action_Weapon4
{
	Weapon4 = me;	
	while(1)
	{
		if (Weapon_DistanceToObstacle<47)
		{
			if (Weapon_DistanceToObstacle == 0)
			{
				temp.x = my.skill12;
			} 
			else
			{
				temp.x = my.skill12+(Weapon_DistanceToObstacle-47);
			}
		}
		
		else
		{
			temp.x = my.skill12;
		}
		
		
		temp.y = my.skill13;
		temp.z = my.skill14;
		my_pos.x = temp.x;
		my_pos.y = temp.y;
		my_pos.z = temp.z;
		vec_rotate(my_pos, camera.pan);
		my_pos.x += camera.x;
		my_pos.y += camera.y;
		my_pos.z += camera.z;
		my.x = my_pos.x;
		my.y = my_pos.y;
		my.z = my_pos.z;
		my.pan = camera.pan;
		my.tilt = camera.tilt;
	
		wait(1);
	}
}

function Weapon_SetStartValues()
{

	// value 1 = yes 
	// value 0 = no
	
	
	// start values weapon 1
	Weapon_Available[0] = 0;  
	Weapon_active[0] = 0;      
	Weapon_MaxAmmo[0] = 200;  
	Weapon_CurrentAmmo[0] = 120;
	Weapon_ShotFrequency[0] = 1;
	
	if (Weapon1 != null)
	{
		Weapon1.invisible = on;
	}
	
	
	// start values weapon 2
	Weapon_Available[1] = 0;  
	Weapon_active[1] = 0;     
	Weapon_MaxAmmo[1] = 400;  
	Weapon_CurrentAmmo[1] = 285;
	Weapon_ShotFrequency[1] = 10;
	
	if (Weapon2 != null)
	{
		Weapon2.invisible = on;
	}
	
	
	// start values weapon 3
	Weapon_Available[2] = 0;  
	Weapon_active[2] = 0;     
	Weapon_MaxAmmo[2] = 80;  
	Weapon_CurrentAmmo[2] = 45; 
	Weapon_ShotFrequency[2] = 1;

	if (Weapon3 != null)
	{
		Weapon3.invisible = on;
	}
	Weapon_Zoom.pos_x = -2000; // no zoom mode at start
	
	
	// start values weapon 4
	Weapon_Available[3] = 0; 
	Weapon_active[3] = 0;    
	Weapon_MaxAmmo[3] = 140; 
	Weapon_CurrentAmmo[3] = 97; 
	Weapon_ShotFrequency[3] = 1;
	
	if (Weapon4 != null)
	{
		Weapon4.invisible = on;
	}
}

function game_init()
{
	var frames;
	var Shot_per_Frame;
	var Shot_per_Frame2 = 0;
	
	Weapon_SetStartValues();
	
		
	while(1)
	{
		// same weapon is visible before and after level_load
		
		if (Weapon_active[0] == 1 && Weapon1 != null)   
		{
			Weapon1.invisible = off;
		}
	
		if (Weapon_active[1] == 1 && Weapon2 != null)   
		{
			Weapon2.invisible = off;
		}
	
		if (Weapon_active[2] == 1 && Weapon3 != null)   
		{
			Weapon3.invisible = off;
		}
	
		if (Weapon_active[3] == 1 && Weapon4 != null)   
		{
			Weapon4.invisible = off;
		}
		
		
		if (menu_active== 0)
		{
		
		statusbar.scale_x = screen_size.x / 800;
		statusbar.scale_y = screen_size.y / 600;
		statusbar.pos_y = screen_size.y -(35 * statusbar.scale_y);
		panel_slash.pos_x = screen_size.x - 50;
		panel_slash.pos_y = screen_size.y - 20;
		
		pan_Health_Player.pos_x = 20;
		pan_Health_Player.pos_y = screen_size.y - 20;
		
		crosshair_pan.pos_x = screen_size.x / 2 - 8; // size crosshair bitmap = 16px x 16px
		crosshair_pan.pos_y = screen_size.y / 2 - 8;
		
		
		// deactivate AmmoDisplay if no weapon is active
		if (Weapon_active[0] == 0) && (Weapon_active[1] == 0) && (Weapon_active[2] == 0) && (Weapon_active[3] == 0) 
		{
			Panel_ValuesWeapon1.pos_x = -200;
			Panel_ValuesWeapon2.pos_x = -200;
			Panel_ValuesWeapon3.pos_x = -200;
			Panel_ValuesWeapon4.pos_x = -200;
		}
		
		if (key_pressed(key_Player_SelectWeapon1) == on) && (Weapon_Available[0] == 1 && player != null)  
		{
			
			if (player.skill4 > 0)  // player.skill4 = players health 
			{
			
			camera.arc = 60;
			mouse_speed_x = mouse_speed_normal_x;  // if not in weapon3 zoom mode -> normal mouse speed
			mouse_speed_y = mouse_speed_normal_y;
			Weapon_Zoom.pos_x = -2000;    // no zoom mode
			crosshair_pan.visible = on;
			Weapon_active[0] = 1;
			Weapon_active[1] = 0;
			Weapon_active[2] = 0;
			Weapon_active[3] = 0;
			Weapon1.invisible = off;
			Weapon2.invisible = on;
			Weapon3.invisible = on;
			Weapon4.invisible = on;
			Panel_ValuesWeapon1.pos_x = screen_size.x - 80;
			Panel_ValuesWeapon1.pos_y = screen_size.y - 20;
			Panel_ValuesWeapon2.pos_x = -200;
			Panel_ValuesWeapon3.pos_x = -200;
			Panel_ValuesWeapon4.pos_x = -200;
			}
		}
		
		if (key_pressed(key_Player_SelectWeapon2) == on) && (Weapon_Available[1] == 1 && player != null)
		{
			if (player.skill4 > 0)  // player.skill4 = players health 
			{
			camera.arc = 60;             
			mouse_speed_x = mouse_speed_normal_x;  // if not in weapon3 zoom mode -> normal mouse speed
			mouse_speed_y = mouse_speed_normal_y;
			Weapon_Zoom.pos_x = -2000;   // no zoom mode
			crosshair_pan.visible = on;
			Weapon_active[0] = 0;
			Weapon_active[1] = 1;
			Weapon_active[2] = 0;
			Weapon_active[3] = 0;
			Weapon1.invisible = on;
			Weapon2.invisible = off;
			Weapon3.invisible = on;
			Weapon4.invisible = on;
			Panel_ValuesWeapon1.pos_x = -200;
			Panel_ValuesWeapon2.pos_x = screen_size.x - 80;
			Panel_ValuesWeapon2.pos_y = screen_size.y - 20;
			Panel_ValuesWeapon3.pos_x = -200;
			Panel_ValuesWeapon4.pos_x = -200;
			}
		}
		
		if (key_pressed(key_Player_SelectWeapon3) == on) && (Weapon_Available[2] == 1 && player != null)
		{
			if (player.skill4 > 0)  // player.skill4 = players health 
			{
			camera.arc = 60;
			mouse_speed_x = mouse_speed_normal_x;  // if not in weapon3 zoom mode -> normal mouse speed
			mouse_speed_y = mouse_speed_normal_y;
			Weapon_Zoom.pos_x = -2000;   // no zoom mode
			crosshair_pan.visible = on;
			Weapon_active[0] = 0;
			Weapon_active[1] = 0;
			Weapon_active[2] = 1;
			Weapon_active[3] = 0;
			Weapon1.invisible = on;
			Weapon2.invisible = on;
			Weapon3.invisible = off;
			Weapon4.invisible = on;
			Panel_ValuesWeapon1.pos_x = -200;
			Panel_ValuesWeapon2.pos_x = -200;
			Panel_ValuesWeapon3.pos_x = screen_size.x - 80;
			Panel_ValuesWeapon3.pos_y = screen_size.y - 20;
			Panel_ValuesWeapon4.pos_x = -200;
		}
		}
		
		if (key_pressed(key_Player_SelectWeapon4) == on) && (Weapon_Available[3] == 1 && player != null)
		{
			if (player.skill4 > 0)  // player.skill4 = players health 
			{
			camera.arc = 60;
			mouse_speed_x = mouse_speed_normal_x;  // if not in weapon3 zoom mode -> normal mouse speed
			mouse_speed_y = mouse_speed_normal_y;
			Weapon_Zoom.pos_x = -2000;    // no zoom mode
			crosshair_pan.visible = on;
			Weapon_active[0] = 0;
			Weapon_active[1] = 0;
			Weapon_active[2] = 0;
			Weapon_active[3] = 1;
			Weapon1.invisible = on;
			Weapon2.invisible = on;
			Weapon3.invisible = on;
			Weapon4.invisible = off;
			Panel_ValuesWeapon1.pos_x = -200;
			Panel_ValuesWeapon2.pos_x = -200;
			Panel_ValuesWeapon3.pos_x = -200;
			Panel_ValuesWeapon4.pos_x = screen_size.x - 80;
			Panel_ValuesWeapon4.pos_y = screen_size.y - 20;
		}
		}
		
		
		
		// left mouse button = fire mode
		if (mouse_left == 1)
		{
			crosshair_pan.visible = on;
			if(Weapon_Available[0] == 1) && (Weapon_active[0] == 1) && (Weapon_CurrentAmmo[0] > 0 && player != null) // weapon must be available und active and current ammo must be more than 0
			{
				if (player.skill4 > 0)  // player.skill4 = players health 
				{
					// combine ShoteFrequency with the framerate
					frames = (1 / time ) * 16;
		
					Shot_per_Frame = Weapon_ShotFrequency[0] / frames;
	
					Shot_per_Frame2 = Shot_per_Frame2 + Shot_per_Frame;
	
							
					Weapon_CurrentAmmo[0] -= 1; // subtract ammo at each shot
							
				
					snd_play(shoot_snd, 70,-100);
					ent_create(bullet_weapon1_mdl, player.pos, move_bulletWeapon1); // create the bullet
					show_muzzle();  // show muzzle flash
					ShotYes = 1;
					Shot_per_Frame2 = 0;
				}
				while(mouse_left == 1) // single shot fire
				{
					wait(1);
				}		
			}
			
			
			
			if(Weapon_Available[1] == 1) && (Weapon_active[1] == 1) && (Weapon_CurrentAmmo[1] > 0 && player != null) // weapon must be available und active and current ammo must be more than 0
			{
				if (player.skill4 > 0)  // player.skill4 = players health 
				{
					// combine ShoteFrequency with the framerate
					frames = (1 / time ) * 16;
		
					Shot_per_Frame = Weapon_ShotFrequency[1] / frames;
	
					Shot_per_Frame2 = Shot_per_Frame2 + Shot_per_Frame;
					if (Shot_per_Frame2 > 1)
					{	
						Weapon_CurrentAmmo[1] -= 1; //subtract ammo at each shot
				
						snd_play(shoot_snd, 70,-100);
				
				
				
						handle_nummer = handle(ent_create(bullet_weapon2_mdl, player.pos, move_bulletWeapon2)); // create the bullet
				
				
						show_muzzle(); // show muzzle flash
						ShotYes = 1;
						Shot_per_Frame2 = 0;
					}
				}
			}
			
			
			if(Weapon_Available[2] == 1) && (Weapon_active[2] == 1) && (Weapon_CurrentAmmo[2] > 0 && player != null) // weapon must be available und active and current ammo must be more than 0
			{
				if (player.skill4 > 0)  // player.skill4 = players health 
				{
					if (camera.arc <= 5)              // if zoom mode is active ...
					{											 // ... deactivate crosshair
						crosshair_pan.visible = off;
					}
				
					// combine ShoteFrequency with the framerate
					frames = (1 / time ) * 16;
		
					Shot_per_Frame = Weapon_ShotFrequency[2] / frames;
	
					Shot_per_Frame2 = Shot_per_Frame2 + Shot_per_Frame;
	
					Weapon_CurrentAmmo[2] -= 1; //subtract ammo at each shot
			
					snd_play(shoot_snd, 70,-100);
					ent_create(bullet_weapon3_mdl, player.pos, move_bulletWeapon3); // create the bullet
					show_muzzle();  // show muzzle flash
					ShotYes = 1;
					Shot_per_Frame2 = 0;
				}
				
				while(mouse_left == 1)  // single shot fire
				{
					wait(1);
				}
			
	
			}
			
			if(Weapon_Available[3] == 1) && (Weapon_active[3] == 1) && (Weapon_CurrentAmmo[3] > 0 && player != null) // weapon must be available und active and current ammo must be more than 0
			{
				
				if (player.skill4 > 0)  // player.skill4 = players health 
				{
					// combine ShoteFrequency with the framerate
					frames = (1 / time ) * 16;
		
					Shot_per_Frame = Weapon_ShotFrequency[3] / frames;
			
					Shot_per_Frame2 = Shot_per_Frame2 + Shot_per_Frame;
			
					Weapon_CurrentAmmo[3] -= 1; // subtract ammo at each shot
				
					snd_play(shoot_snd, 70,-100);
					ent_create(bullet_Weapon4_mdl, player.pos, move_bulletWeapon4); // create the bullet
					show_muzzle();  // show muzzle flash
					ShotYes = 1;
					Shot_per_Frame2 = 0;
				}
				
				while(mouse_left == 1)   // single shot fire
				{
					wait(1);
				}
			
			
			}			
		}
		
		if (mouse_right == 1)   // activate or deactivate zoom mode for weapon 3
			{
				if (player.skill4 > 0)  // player.skill4 = players health 
				{
				
				Weapon_Zoom.scale_x = screen_size.x / 800;
				Weapon_Zoom.scale_y = screen_size.y / 600;
				
				
				if (Weapon_Available[2] == 1) && (Weapon_active[2] == 1)
				{
					if (camera.arc == 60)
					{
						mouse_speed_x = mouse_speed_Weapon3ZoomMode_x;  // slow mousespeed in weapon3 zoom mode
						mouse_speed_y = mouse_speed_Weapon3ZoomMode_y;
						crosshair_pan.visible = off;
						Weapon_Zoom.pos_x = 0;
						while(camera.arc >5)
						{
							camera.arc -= 2 * time;
							if (camera.arc > 60)
							{
								camera.arc = 60;
								wait(1);
							}
						}
		
					} 
					else
					{
						mouse_speed_x = mouse_speed_normal_x;   // if not in weapon3 zoom mode -> normal mouse speed
						mouse_speed_y = mouse_speed_normal_y;
						crosshair_pan.visible = on;
						Weapon_Zoom.pos_x = -2000;
						camera.arc = 60;
					}
				}
				
				while(mouse_right == 1)
				{
					wait(1);
				}
			}
			}
		}	
		else
		{
			Weapon_Zoom.pos_x = -2000;  // wenn Pausemen angezeigt und zufllig der Zoom der Ar18 aktiv ist, dann
												 // diese Anzeige ausschalten
			crosshair_pan.pos_x = 2000; // Fadenkreuz ausschalten	
		}										 
		
		wait(1);	
	
	}
}




action MuzzleFlash
{
	E_MuzzleFlash = me;
	
	my.invisible = on;
	my.passable = on;
	my.scale_x = 0.8;
	my.scale_y = 0.8;
	my.scale_z = 0.8;
	
	while(1)
	{
		
		if (Weapon_active[0] == 1)
		{
			vec_for_vertex(temp, Weapon1, 43);   // attach muzzle flash to a special vertex
		}
		
		if (Weapon_active[1] == 1)
		{
			vec_for_vertex(temp, Weapon2, 2);    // attach muzzle flash to a special vertex
		}
		
		if (Weapon_active[2] == 1)
		{
			vec_for_vertex(temp, Weapon3, 1);    // attach muzzle flash to a special vertex
		}
		
		if (Weapon_active[3] == 1)
		{
			vec_for_vertex(temp, Weapon4, 25);   // attach muzzle flash to a special vertex
		}
		my.x = temp.x;
		my.y = temp.y;
		my.z = temp.z;
		my.pan = camera.pan;
		my.tilt = camera.tilt;
		my.roll = camera.roll;
		
	
	
		wait(1);
	}
}



define Ammo, skill1;
define Area, skill2;
//uses: Ammo,Area;
action Weapon1_Colt45                // pick up weapons in the game
{
	my.enable_impact = me;
	my.event = get_Weapon1;
	
	while(1)
	{

		if (activeArea[my.Area] == 0)  // if area is active
		{
			my.invisible = off;
			my.passable = off;
		

			if (my != null && menu_active == 0)
			{
				my.pan += 3 * time;
				wait(1);
			}

			else
			{
				if (ShotYes == 1)
				{
					ShotYes = 0;
				}
			}
		}
		else
		{
			my.passable = on;
			my.invisible = on;
		}
		
		wait(1);
	}
}

define Ammo, skill1;
define Area, skill2;
//uses: Ammo, Area;
action Weapon2_Atomiser             // pick up weapons in the game
{
	my.enable_impact = me;
	my.event = get_Weapon2;
	
	while(1)
	{
		if (activeArea[my.Area] == 0)  // if area is active
		{
			my.invisible = off;
			my.passable = off;

			if (my != null && menu_active == 0)
			{
				my.pan += 3 * time;
				wait(1);
			}
			else
			{
				if (ShotYes == 1)
				{
					ShotYes = 0;
				}
			}
		}
		else
		{
			my.invisible = on;
			my.passable = on;
		}
		wait(1);
	}
}

define Ammo, skill1;
define Area, skill2;
//uses: Ammo, Area;
action Weapon3_Ar18                       // pick up weapons in the game
{
	my.enable_impact = me;
	my.event = get_Weapon3;
	
	while(1)
	{
		if (activeArea[my.Area] == 0)  // if area is active
		{
			my.invisible = off;
			my.passable = off;

			if (my != null && menu_active == 0)
			{
				my.pan += 3 * time;
				wait(1);
			}
			else
			{
				if (ShotYes == 1)
				{
					ShotYes = 0;
				}
			}
		}
		else
		{
			my.passable = on;
			my.invisible = on;
		}
		wait(1);
	}
}

define Ammo, skill1;
define Area, skill2;
//uses: Ammo, Area;
action Weapon4_Destructor                     // pick up weapons in the game
{
	my.enable_impact = me;
	my.event = get_Weapon4;
	
	while(1)
	{
		if (activeArea[my.Area] == 0)  // if area is active
		{
			my.invisible = off;
			my.passable = off;
			

			if (my != null && menu_active == 0)
			{
				my.pan += 3 * time;
				wait(1);
			}
			else
			{
				if (ShotYes == 1)
				{
					ShotYes = 0;
				}
			}
		}
		else
		{
			my.passable = on;
			my.invisible = on;
		}
		wait(1);
	}
}


function get_Weapon1()
{
	if (you == player)
	{
		wait(1);
		Weapon_Available[0] = 1;
		Weapon_CurrentAmmo[0] += my.skill1;             // add ammo
		if (Weapon_CurrentAmmo[0] > Weapon_MaxAmmo[0])  // current ammo is never more than max ammo		 
		{																		 
			Weapon_CurrentAmmo[0] = Weapon_MaxAmmo[0];   
		}
		snd_play(gotgun_snd, 80,0);
		ent_remove(me);
	}
}

function get_Weapon2()
{
	if (you == player)
	{
		wait(1);
		Weapon_Available[1] = 1;
		Weapon_CurrentAmmo[1] += my.skill1;             // add ammo
		if (Weapon_CurrentAmmo[1] > Weapon_MaxAmmo[1])  // current ammo is never more than max ammo		  
		{																		 
			Weapon_CurrentAmmo[1] = Weapon_MaxAmmo[1];   
		}
		snd_play(gotgun_snd, 80,0);
		ent_remove(me);
	}
}

function get_Weapon3()
{
	if (you == player)
	{
		wait(1);
		Weapon_Available[2] = 1;
		Weapon_CurrentAmmo[2] += my.skill1;             // add ammo
		if (Weapon_CurrentAmmo[2] > Weapon_MaxAmmo[2])  // current ammo is never more than max ammo		 
		{																		 
			Weapon_CurrentAmmo[2] = Weapon_MaxAmmo[2];   
		}
		snd_play(gotgun_snd, 80,0);
		ent_remove(me);
	}
}

function get_Weapon4()
{
	if (you == player)
	{
		wait(1);
		Weapon_Available[3] = 1;
		Weapon_CurrentAmmo[3] += my.skill1;             // add ammo
		if (Weapon_CurrentAmmo[3] > Weapon_MaxAmmo[3])  // current ammo is never more than max ammo		  
		{																		  
			Weapon_CurrentAmmo[3] = Weapon_MaxAmmo[3];   
		}
		snd_play(gotgun_snd, 80,0);
		ent_remove(me);
	}
}



function remove_me2()
{	
	my.skill99 = 1;
	my.skill96 = normal.pan;
	my.skill97 = normal.tilt;
	my.skill98 = normal.roll;
	
	my.skill93 = normal.x;
	my.skill94 = normal.y;
	my.skill95 = normal.z;
}



function move_bulletWeapon1()  // movement bullet from weapon 1
{
	wait(1);
	my.scale_x = 0.2;
	my.scale_y = 0.2;
	my.scale_z = 0.2;
	my.push = 0;
	my.invisible = on;
	my.enable_entity = on;
	my.enable_block = on;
	my.event = remove_me2;
	my.passable = on;
	my.pan = camera.pan;
	my.tilt = camera.tilt;
	my.skill20 = 0;
	my.skill80 = 3;
	bullet_speed.x = 60;
	bullet_speed.y = 0;
	bullet_speed.z = 0;
	bullet_speed * = time;
	my.skill99 = 0;
	my.z = my.z + 30;
	my.polygon = on;
	
	my.skill1 = 10;
	my.skill2 = 0.1;
	my.skill3 = 0.1;
	my.skill4 = 0.1;
	my.skill5 = 0.1;
	my.flag2 = on;
	
	while(my.skill99 == 0)
	{	
	   if (my.skill20 < 50)
		{
			if (my == null) 
			{
				return;
			}
			
			if (my.skill20 < 0.01) // coll. not with player
			{
				my.passable = on;
			}
			else
			{
				my.passable = off;
			}
			my.skill20 += 0.01 * time;

			c_move(my,bullet_speed,nullvector,ignore_you );
		
			wait(1);
		}
	}
	wait(1);
		
	ent_remove(me);
	}	
}

function move_bulletWeapon2() // movement bullet from weapon 2
{
	wait(1);
	my.scale_x = 0.2;
	my.scale_y = 0.2;
	my.scale_z = 0.2;
	my.push = 0;
	my.invisible = on;
	my.enable_entity = on;
	my.enable_block = on;
	my.event = remove_me2;
	my.passable = on;
	my.pan = camera.pan;
	my.tilt = camera.tilt;
	my.skill20 = 0;
	my.skill80 = 3;
	bullet_speed.x = 60;
	bullet_speed.y = 0;
	bullet_speed.z = 0;
	bullet_speed * = time;
	my.skill99 = 0;
	my.z = my.z + 30;
	my.polygon = on;
	
	my.skill1 = 10;
	my.skill2 = 0.1;
	my.skill3 = 0.1;
	my.skill4 = 0.1;
	my.skill5 = 0.1;
	my.flag2 = on;
	
	while(my.skill99 == 0)
	{	
	   if (my.skill20 < 50)
		{
			
		
		if (my == null) 
		{
			return;
		}
		if (my.skill20 < 0.1) // coll. not with player
		{
			my.passable = on;
		}
		else
		{
			my.passable = off;
		}
		my.skill20 += 0.1 * time;

		c_move(my,bullet_speed,nullvector,ignore_you );
		
		wait(1);
		}
		
		
		}
		wait(1);
		
		ent_remove(me);
	}	
}

function move_bulletWeapon3()  // movement bullet from weapon 3
{
	wait(1);
	my.scale_x = 0.2;
	my.scale_y = 0.2;
	my.scale_z = 0.2;
	my.push = 0;
	my.invisible = on;
	my.enable_entity = on;
	my.enable_block = on;
	my.event = remove_me2;
	my.passable = on;
	my.pan = camera.pan;
	my.tilt = camera.tilt;
	my.skill20 = 0;
	my.skill80 = 3;
	bullet_speed.x = 60;
	bullet_speed.y = 0;
	bullet_speed.z = 0;
	bullet_speed * = time;
	my.skill99 = 0;
	my.z = my.z + 30;
	my.polygon = on;
	
	my.skill1 = 10;
	my.skill2 = 0.1;
	my.skill3 = 0.1;
	my.skill4 = 0.1;
	my.skill5 = 0.1;
	my.flag2 = on;
	
	while(my.skill99 == 0)
	{	
	   if (my.skill20 < 50)
		{
			
		
		if (my == null) 
		{
			return;
		}
		if (my.skill20 < 0.1) // coll. not with player
		{
			my.passable = on;
		}
		else
		{
			my.passable = off;
		}
		my.skill20 += 0.1 * time;

		c_move(my,bullet_speed,nullvector,ignore_you );
		
		wait(1);
		}
		
		
		}
		wait(1);
		
		ent_remove(me);
	}	
}

function move_bulletWeapon4() // movement bullet from weapon 4
{
	wait(1);
	my.scale_x = 0.2;
	my.scale_y = 0.2;
	my.scale_z = 0.2;
	my.push = 0;
	my.invisible = on;
	my.enable_entity = on;
	my.enable_block = on;
	my.event = remove_me2;
	my.passable = on;
	my.pan = camera.pan;
	my.tilt = camera.tilt;
	my.skill20 = 0;
	my.skill80 = 3;
	bullet_speed.x = 60;
	bullet_speed.y = 0;
	bullet_speed.z = 0;
	bullet_speed * = time;
	my.skill99 = 0;
	my.z = my.z + 30;
	my.polygon = on;
	
	my.skill1 = 10;
	my.skill2 = 0.1;
	my.skill3 = 0.1;
	my.skill4 = 0.1;
	my.skill5 = 0.1;
	my.flag2 = on;
	
	while(my.skill99 == 0)
	{	
	   if (my.skill20 < 50)
		{
			
		
		if (my == null) 
		{
			return;
		}
		if (my.skill20 < 0.1) // coll. not with player
		{
			my.passable = on;
		}
		else
		{
			my.passable = off;
		}
		my.skill20 += 0.1 * time;

		c_move(my,bullet_speed,nullvector,ignore_you );
		
		wait(1);
		}
		
		
		}
		wait(1);
		
		ent_remove(me);
	}	
}

function remove_me()
{
	wait (2);
	
	if(event_type == event_friction)
	{
		snd_play(gotgun_snd, 80,0);
	}
	ent_remove (me);
}


function show_muzzle()
{
	
		E_MuzzleFlash.passable=on;
		E_MuzzleFlash.bright=on;
		E_MuzzleFlash.nofog=on;
	
	
		E_MuzzleFlash.transparent = on;
		E_MuzzleFlash.alpha = 50;
		E_MuzzleFlash.invisible = off;
		
		while(E_MuzzleFlash.alpha>20)
		{
			E_MuzzleFlash.alpha=max(0, E_MuzzleFlash.alpha-time*40);
			wait(1);
		}
	
		E_MuzzleFlash.invisible=on;
	
}




/////////////////// 
// med pack


function med_pack_event()
{
	if (you == player) && (player.skill4 < player.skill3) // only the player can pick up the med pack ...
	{																						// ... and players health is less than players max health
		wait(1);
		player.skill4 += my.skill1;  // add health
		
		if (player.skill4 > player.skill3)    // if max health less than current health ...
		{												  // ... current health = max health
			player.skill4 = player.skill3;
		}
	
	// player.skill3 = max health
   // player.skill4 = current health
   
	snd_play(gotmed_snd, 60,0);  // play sound at pick up
	ent_remove(me);              // destroy med pack
	}         
	
}




define MedPackValue, skill1;             // how many health has the med pack
define RotationSpeed, skill2;            // rotation speed ... 
define Area, skill3;
define Rotation, flag1;						  // ... if this flag is set
// title: Med Pack Values
// uses: MedPackValue, RotationSpeed, Area, Rotation
action med_pack 
{
	
	
	my.enable_impact = on;
	my.event = med_pack_event;
	
	if (my.RotationSpeed == 0 && my.Rotation == on)  // if rotation flag is set and rotation speed is 0 ...
	{																 // ... the rotation speed is 2 ( standard value )
		my.RotationSpeed = 2;                         
	}
	
	if (my.MedPackValue == 0) // if you forgot to set the medpackvalue in wed -> 20 is standard value
	{
		my.MedPackValue = 20;
	}
	
	while(my != null)
	{
		if ( menu_active == 0 )
		{
			
		
		
		if (my.Rotation == on)  // if rotation flag is set -> med pack rotates with the given rotation speed
		{
			
			my.pan += my.RotationSpeed * time; // ... rotate the med
		}
		
		if (player.skill3 == player.skill4 || activeArea[my.Area] == 1)   // set passable if the player do not need health ... 
		{
			my.passable = on;
		}
		else
		{
			my.passable = off;                 // ... otherwise set passable off
		}
		
		if (activeArea[my.Area] == 0)  // if area is active
		{
			my.invisible = off;
		}
		else
		{
			my.invisible = on;
		}
		
		
		}
		
		
		wait(1);
	}
}


/////////////////////
// ammo pack

// weapon 1

function mun_pack_weapon1_event()
{
	if (you == player) && (Weapon_available[0] == 1) && (Weapon_CurrentAmmo[0] < Weapon_MaxAmmo[0])
	// only the player can pick up the ammo pack AND
	// weapon 1 is available AND
	// current ammo is less than max ammo
	
	{																						
		wait(1);
		Weapon_Currentammo[0] += my.skill1;  // add to current ammo
		
		if (Weapon_CurrentAmmo[0] > Weapon_MaxAmmo[0]) // max ammo is never less than current ammo
		{														 
			Weapon_CurrentAmmo[0] = Weapon_MaxAmmo[0];
		}
	
		snd_play(gotgun_snd, 80,0);  // play sound at pick up
		ent_remove(me);   			  // destroy ammo pack
	}         
	
}

define ammoWeapon1Value skill1;             // how many bullets are in this ammo pack?
define RotationSpeed, skill2;               // rotates with the given speed ...
define Area, skill3;
define Rotation, flag1;                     // ... if this flag is set
// title: ammo pack weapon 1 values
// uses: ammoWeapon1Value, RotationSpeed, Area, Rotation
action ammo_Weapon1
{
	
	my.enable_impact = on;
	my.event = mun_pack_weapon1_event;
	
	
	if (my.RotationSpeed == 0 && my.Rotation == on)  // if rotation flag is set and rotation speed is 0 ...
	{																 // ... rotation speed is 2 ( standard value )
		my.RotationSpeed = 2;                         
	}
	
	if (my.ammoWeapon1Value == 0) // if you forgot to set the ammo value in wed -> 20 is standard value
	{
		my.ammoWeapon1Value = 20;
	}
	
	while(my != null)
	{
		if ( menu_active == 0 )
		{
			
		
		
		if (my.Rotation == on)  
		{
			
			my.pan += my.RotationSpeed * time; // ... rotate the ammo pack if rotation flag is set
		}
	
	
		// current ammo = max ammo OR no weapon available? -> you can't pick up the ammo pack
		if (Weapon_CurrentAmmo[0] == Weapon_MaxAmmo[0] || Weapon_Available[0] == 0 || activeArea[my.Area] == 1)
		{
			my.passable = on;
		}
		else
		{
			my.passable = off;
		}
		
		if (activeArea[my.Area] == 0)  // if area is active
		{
			my.invisible = off;
		}
		else
		{
			my.invisible = on;
		}
		
		}
		wait(1);
	}
}


/////////////////////
// ammo pack

// weapon 2

function mun_pack_weapon2_event()
{
	if (you == player) && (Weapon_Available[1] == 1) && (Weapon_CurrentAmmo[1] < Weapon_MaxAmmo[1])
	// only the player can pick up the ammo pack AND
	// weapon 1 is available AND
	// current ammo is less than max ammo
	{																						
	
	wait(1);
	
	
	
	Weapon_CurrentAmmo[1] += my.skill1;  // add to current ammo
	if (Weapon_CurrentAmmo[1] > Weapon_MaxAmmo[1]) // max ammo is never less than current ammo
	{														 
		Weapon_CurrentAmmo[1] = Weapon_MaxAmmo[1];
	}
	
	snd_play(gotgun_snd, 80,0);  // play sound at pick up
	ent_remove(me);   			  // destroy ammo packn  
	}         
	
}

define ammoWeapon2Value skill1;             // how many bullets are in this ammo pack?
define RotationSpeed, skill2;               // rotates with the given speed ...
define Area, skill3;
define Rotation, flag1;                     // ... if this flag is set
// title: ammo pack weapon 2 values
// uses: ammoWeapon2Value, RotationSpeed, Area, Rotation
action ammo_Weapon2
{
	
	my.enable_impact = on;
	my.event = mun_pack_weapon2_event;
	
	
	if (my.RotationSpeed == 0 && my.Rotation == on)  // if rotation flag is set and rotation speed is 0 ...
	{																 // ... rotation speed is 2 ( standard value )
		my.RotationSpeed = 2;                         
	}
	
	if (my.ammoWeapon2Value == 0) /// if you forgot to set the ammo value in wed -> 20 is standard value
	{
		my.ammoWeapon2Value = 20;
	}
	
	while(my != null)
	{
		if ( menu_active == 0 )
		{
			
			
		
			if (my.Rotation == on)  
			{
				my.pan += my.RotationSpeed * time; // ... rotate the ammo pack if rotation flag is set
			}
		
		// current ammo = max ammo OR no weapon available? -> you can't pick up the ammo pack
		if (Weapon_CurrentAmmo[1] == Weapon_MaxAmmo[1] || Weapon_Available[1] == 0 || activeArea[my.Area] == 1)
		{
			my.passable = on;
		}
		else
		{
			my.passable = off;
		}
		
		if (activeArea[my.Area] == 0)  // if area is active
			{
				my.invisible = off;
			}
			else
			{
				my.invisible = on;
			}
	}
		wait(1);
	}
}


/////////////////////
// ammo pack

// weapon 3

function mun_pack_weapon3_event()
{
	if (you == player) && (Weapon_Available[2] == 1) && (Weapon_CurrentAmmo[2] < Weapon_MaxAmmo[2])
	// only the player can pick up the ammo pack AND
	// weapon 1 is available AND
	// current ammo is less than max ammo
	{																						
	
	wait(1);
	
	
	
	Weapon_CurrentAmmo[2] += my.skill1;  // add to current ammo
	if (Weapon_CurrentAmmo[2] > Weapon_MaxAmmo[2]) // max ammo is never less than current ammo
	{														 
		Weapon_CurrentAmmo[2] = Weapon_MaxAmmo[2];
	}
	
	snd_play(gotgun_snd, 80,0);  // play sound at pick up
	ent_remove(me);   			  // destroy ammo pack 
	}         
	
}

define ammoWeapon3Value skill1;             // how many bullets are in this ammo pack?
define RotationSpeed, skill2;               // rotates with the given speed ...
define Area, skill3;
define Rotation, flag1;                     // ... if this flag is set
// title: ammo pack weapon 3 values
// uses: ammoWeapon3Value, RotationSpeed, Area, Rotation
action ammo_Weapon3
{
	
	my.enable_impact = on;
	my.event = mun_pack_weapon3_event;
	
	if (my.RotationSpeed == 0 && my.Rotation == on)  // if rotation flag is set and rotation speed is 0 ...
	{																 // ... rotation speed is 2 ( standard value )
		my.RotationSpeed = 2;                         
	}
	
	if (my.ammoWeapon3Value == 0) // if you forgot to set the ammo value in wed -> 20 is standard value
	{
		my.ammoWeapon3Value = 20;
	}
	
	while(my != null)
	{
		if ( menu_active == 0 )
		{
			
		if (activeArea[my.Area] == 0)  // if area is active
		{
			my.passable = off;
			my.invisible = off;
		}
		else
		{
			my.passable = on;
			my.invisible = on;
		}
		
		if (my.Rotation == on)  
		{
			
			my.pan += my.RotationSpeed * time; // ... rotate the ammo pack if rotation flag is set
		}
		
		// current ammo = max ammo OR no weapon available? -> you can't pick up the ammo pack
		if (Weapon_CurrentAmmo[2] == Weapon_MaxAmmo[2] || Weapon_Available[2] == 0 || activeArea[my.Area] == 1)
		{
			my.passable = on;
		}
		else
		{
			my.passable = off;
		}
		
		
		if (activeArea[my.Area] == 0)  // if area is active
			{
				my.invisible = off;
			}
			else
			{
				my.invisible = on;
			}
		
		}
		wait(1);
	}
}


/////////////////////
// ammo pack

// weapon 4

function mun_pack_weapon4_event()
{
	if (you == player) && (Weapon_Available[3] == 1) && (Weapon_CurrentAmmo[3] < Weapon_MaxAmmo[3])
	// only the player can pick up the ammo pack AND
	// weapon 1 is available AND
	// current ammo is less than max ammo
	{																						
	
	wait(1);
	
	
	
	Weapon_CurrentAmmo[3] += my.skill1;  // add to current ammo
	
	if (Weapon_CurrentAmmo[3] > Weapon_MaxAmmo[3]) // max ammo is never less than current ammo
	{														 
		Weapon_CurrentAmmo[3] = Weapon_MaxAmmo[3];
	}
	
	snd_play(gotgun_snd, 80,0);  // play sound at pick up
	ent_remove(me);   			  // destroy ammo pack  
	}         
	
}

define ammoWeapon4Value skill1;             // how many bullets are in this ammo pack?
define RotationSpeed, skill2;               // rotates with the given speed ...
define Area, skill3;
define Rotation, flag1;                     // ... if this flag is set
// title: ammo pack weapon 4 values
// uses: ammoWeapon4Value, RotationSpeed, Area, Rotation
action ammo_Weapon4
{
	
	
	my.enable_impact = on;
	my.event = mun_pack_weapon4_event;
	
	if (my.RotationSpeed == 0 && my.Rotation == on)  // if rotation flag is set and rotation speed is 0 ...
	{																 // ... rotation speed is 2 ( standard value )
		my.RotationSpeed = 2;                         
	}
	
	if (my.ammoWeapon4Value == 0) // if you forgot to set the ammo value in wed -> 20 is standard value
	{
		my.ammoWeapon4Value = 20;
	}
	
	while(my != null)
	{
		if ( menu_active == 0 )
		{
			
		if (activeArea[my.Area] == 0)  // if area is active
		{
			my.passable = off;
			my.invisible = off;
		}
		else
		{
			my.passable = on;
			my.invisible = on;
		}
		
		if (my.Rotation == on)  
		{
			
			my.pan += my.RotationSpeed * time; // ... rotate the ammo pack if rotation flag is set
		}
		
		// current ammo = max ammo OR no weapon available? -> you can't pick up the ammo pack
		if (Weapon_CurrentAmmo[3] == Weapon_MaxAmmo[3] || Weapon_Available[3] == 0 || activeArea[my.Area] == 1)
		{
			my.passable = on;
		}
		else
		{
			my.passable = off;
		}
		
		if (activeArea[my.Area] == 0)  // if area is active
			{
				my.invisible = off;
			}
			else
			{
				my.invisible = on;
			}
	}
		wait(1);
	}
}
